//var dashsocket = SocketService('dashboard.ws');

var Tab = $$({name:null,
              active:null,
              page: null},
             {format: '<a class="item" data-bind="name" />'},
             {'click &': function() {
                 this.model.set({active: true});

                 var newactive = this.model.get('name');
                 this.trigger('tab-activated', this);

                 var page = this.model.get('page');
                 page.view.$().show();
              },

              'change:active': function(e) {
                  if (this.model.get('active') == true) {
                      this.view.$().addClass('active');
                  } else {
                      this.view.$().removeClass('active');
                      this.model.get('page')
                          .view.$().hide();
                  }
              }
             }
            );


var TabCollection =
$$({tabs: [], active: null},
   {format: '<div class="ui tabular menu" />'},
   {'create': function(){
       var tabs = this.model.get('tabs');
       this.model.set({active:tabs[0]});
       tabs.forEach(function(t){
           this.append(t);
       }, this);
   },

    'child:tab-activated': function(e, obj){
        this.model.get('active')
            .model.get('page')
            .view.$()
            .toggle();

        this.model.set({active: obj});
        this.each(function(){
            if (this != obj){
                this.model.set({'active': null});
            }
        });
    }
   });


var Page = $$({content: null,
               title: null},
              {format: '<div class="content" />'},
              {'create': function(e) {
                  // start hidden
                  this.view.$().hide();
              }
              });


var VDivider = $$({},
                  {format: '<div class="ui vertical divider" data-bind="text" />'},
                  {});


var StateCol = $$({label: null},
                  {format: ""
                   + "<div class='three wide column'>"
                   + "<div class='ui ribbon label' data-bind='label'/>"
                   + "</div>"},
                  {'create': function(){
                      console.log(this.model.get("label"));
                  }});


var StateCols = $$({label: null},
                   {format:"<div class='ui grid divided' data-bind='label' />"},
                   {});

var State = $$(Page, {title:'State'},
               {},
               {'create':function(){
                   var statecols = $$(StateCols);
                   this.model.set({content: statecols});
                   this.append(statecols);
                   statecols
                       .append($$(StateCol, {label: "Target"}))
                       .append($$(StateCol, {label: "In Flight"}))
                       .append($$(StateCol, {label: "Current"}));
               }});

var Health = $$(Page, {title:'Health', content: null});
var Waterfall = $$(Page, {title:'Waterfall', content: null});
var Logs = $$(Page, {title:'Logs', content: null});


$(document).ready(
    function() {
        var pagelist = [State, Health, Waterfall, Logs];
        var tabs = pagelist.map(
            function(page) {
                return $$(Tab, {page: page, name: page.model.get('title')});
            });

        var tabcol = $$(TabCollection, {tabs: tabs});
        $$.document.append(tabcol);

        pagelist.forEach(function(page){
            $$.document.append(page);
        });

        var state = tabs[0];
        state.model.set({active: true});


        var page = state.model.get('page');
        page.view.$().show();
    });
